/*				 -*- buffer-read-only: t -*- vi: set ro:
** 
** DO NOT EDIT THIS FILE   (prefs.h)
** 
** It has been AutoGen-ed  Wednesday May 23, 2001 at 08:52:18 AM CEST
** From the definitions    prefs.def
** and the template file   prefs
*/

/*
** Heroes is free software.
** 
** You may redistribute it and/or modify it under the terms of the
** GNU General Public License, as published by the Free Software
** Foundation; either version 2, or (at your option) any later version.
** 
** Heroes is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
** See the GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Heroes.  See the file "COPYING".  If not,
** write to:  The Free Software Foundation, Inc.,
**            59 Temple Place - Suite 330,
**            Boston,  MA  02111-1307, USA.
*/


#ifndef HEROES__PREFS__H
#define HEROES__PREFS__H

typedef struct {

  /* Whether the radar must be drawn.  */
  bool                 radar_map;

  /* Whether game counters must be drawn.  */
  bool                 display_infos;

  /* Gamma setting.  */
  u8_t                 luminance;

  /* Whether the camera moves with inertia.  */
  bool                 inertia;

  /* Whether music is enabled.  */
  bool                 music;

  /* Music volume.  */
  u8_t                 music_volume;

  /* Whether sound effects are enabled.  */
  bool                 sfx;

  /* Sound effects volume.  */
  u8_t                 sfx_volume;

  /* Control type for player one (0=key, 1=joy).  */
  u8_t                 ctrl_one;

  /* Whether player one wants autopilot.  */
  bool                 autopilot_one;

  /* Control type for player two (0=key, 1=joy).  */
  u8_t                 ctrl_two;

  /* Whether player two wants autopilot.  */
  bool                 autopilot_two;

  /* Speed of the game.  */
  u8_t                 speed;

  /* Index of the number of rounds (not the number itself).  */
  u8_t                 gamerounds;

  /* Color for players.  */
  u8_t                 player_color[4];

  /* How extras levels are included.  */
  u8_t                 extras;

  keycode_t            player_keys[2][6];

  /* Keycodes for player one.  */
  /* keycode_t            player_keys[0][6]; */

  /* Keycodes for player two.  */
  /* keycode_t            player_keys[1][6]; */

} prefs_t;

extern prefs_t opt;

void reinit_preferences (void);
void free_preferences (void);
void output_preferences (FILE* fs);
bool save_preferences (void);
bool load_preferences (void);

#endif /* HEROES__PREFS__H */

